package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.WFDynamicUser;
import com.sa.ibiz.demo.demo.service.WFDynamicUserService;
import com.sa.ibiz.demo.demo.service.dto.WFDynamicUserSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/wfdynamicuser")
public class WFDynamicUserResource
{
	@Autowired
	private WFDynamicUserService service;


	@PostMapping(value = "/update")
	public ResponseEntity<WFDynamicUser> update(@Validated @RequestBody WFDynamicUser data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流动态用户[update]操作发生错误","WFDynamicUser",data.getWfdynamicuserid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/checkKey")
	public ResponseEntity<WFDynamicUser> checkKey(@Validated @RequestBody WFDynamicUser data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流动态用户[checkKey]操作发生错误","WFDynamicUser",data.getWfdynamicuserid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<WFDynamicUser> getDraft(@Validated @RequestBody WFDynamicUser data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流动态用户[getDraft]操作发生错误","WFDynamicUser","");
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/create")
	public ResponseEntity<WFDynamicUser> create(@Validated @RequestBody WFDynamicUser data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流动态用户[create]操作发生错误","WFDynamicUser",data.getWfdynamicuserid().toString());
		return ResponseEntity.ok().body(data);
	}
	@GetMapping(value = "/{id}")
	public ResponseEntity<WFDynamicUser> get(@Validated @PathVariable String id){
		WFDynamicUser data=new WFDynamicUser();
		data.setWfdynamicuserid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("工作流动态用户[get]操作发生错误","WFDynamicUser",id.toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/remove")
	public ResponseEntity<WFDynamicUser> remove(@Validated @RequestBody WFDynamicUser data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流动态用户[remove]操作发生错误","WFDynamicUser",data.getWfdynamicuserid().toString());
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<WFDynamicUser>> searchDefaultPage(@Validated @RequestBody WFDynamicUserSearchFilter filter){
		Page<WFDynamicUser> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<WFDynamicUser>> listDefault(@Validated @RequestBody WFDynamicUserSearchFilter filter){
		List<WFDynamicUser> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
